'use strict';
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var util = require('util');
var spawn = require('child_process').spawn;
var path = require('path');
var format = require('util').format;
var execa = require('execa');
var fse = require('fs-extra');
var importLazy = require('import-lazy')(require);
var _ = require('lodash');
var configstore = importLazy('configstore');
var chalk = importLazy('chalk');
var semverDiff = importLazy('semver-diff');
var latestVersion = importLazy('latest-version');
var isNpm = importLazy('is-npm');
var isInstalledGlobally = importLazy('is-installed-globally');
var isYarnGlobal = importLazy('is-yarn-global');
var hasYarn = importLazy('has-yarn');
var boxen = importLazy('boxen');
var xdgBasedir = importLazy('xdg-basedir');
var isCi = importLazy('is-ci');
var mapWodaXConfigs = require('./wodax-config');
/**
 * 判断是否为当前包
 * @param packageName 包名
 * @returns {boolean}
 */
function matchCurrentPackage(packageName) {
    try {
        var curPKG = require("./package");
        return packageName === curPKG.name;
    }
    catch (e) {
        console.error(e);
    }
    return false;
}
var ONE_DAY = 1000 * 60 * 60 * 24;
var UpdateNotifier = /** @class */ (function () {
    function UpdateNotifier(options) {
        var _a, _b, _c, _d;
        options.pkg = options.pkg || {};
        options.distTag = options.distTag || 'latest';
        // Reduce pkg to the essential keys. with fallback to deprecated options
        options.pkg = {
            name: options.pkg.name || options.packageName,
            version: options.pkg.version || options.packageVersion,
            dependenciesType: options.pkg.dependenciesType || options.dependenciesType
        };
        if (!options.pkg.name || !options.pkg.version) {
            throw new Error('pkg.name and pkg.version required');
        }
        options.runCheckByFuncName = ((_a = options) === null || _a === void 0 ? void 0 : _a.runCheckByFuncName) || 'checkNpm'; /// default use checkNpm
        options.templateClassId = ((_b = options) === null || _b === void 0 ? void 0 : _b.templateClassId) || ''; /// eg. "00-wodax-ebmp"
        options.templateKey = ((_c = options) === null || _c === void 0 ? void 0 : _c.templateKey) || ''; /// eg. "business-app-backstage"
        options.templateVersion = ((_d = options) === null || _d === void 0 ? void 0 : _d.templateVersion) || ''; /// eg. "0.1.0"
        this.options = options;
        this.packageName = options.pkg.name;
        this.packageVersion = options.pkg.version;
        this.dependenciesType = options.pkg.dependenciesType || 'dependencies';
        this.templateClassId = options.templateClassId;
        this.templateKey = options.templateKey;
        this.templateVersion = options.templateVersion;
        this.runCheckByFuncName = options.runCheckByFuncName;
        this.updateCheckInterval = typeof options.updateCheckInterval === 'number' ? options.updateCheckInterval : ONE_DAY;
        this.hasCallback = typeof options.callback === 'function';
        this.callback = options.callback || (function () {
        });
        this.disabled = 'NO_UPDATE_NOTIFIER' in process.env ||
            process.argv.includes('--no-update-notifier') ||
            isCi();
        this.shouldNotifyInNpmScript = options.shouldNotifyInNpmScript;
        if (!this.disabled) {
            try {
                var ConfigStore = configstore();
                this.config = new ConfigStore("update-notifier-" + this.packageName, {
                    optOut: false,
                    // Init with the current time so the first check is only
                    // after the set interval, so not to bother users right away
                    lastUpdateCheck: Date.now()
                });
            }
            catch (error) {
                // Expecting error code EACCES or EPERM
                var message_1 = chalk().yellow(format(' %s update check failed ', options.pkg.name)) +
                    format('\n Try running with %s or get access ', chalk().cyan('sudo')) +
                    '\n to the local update config store via \n' +
                    chalk().cyan(format(' sudo chown -R $USER:$(id -gn $USER) %s ', xdgBasedir().config));
                process.on('exit', function () {
                    console.error('\n' + boxen()(message_1, { align: 'center' }));
                });
            }
        }
    }
    /**
     * Check the update informations
     */
    UpdateNotifier.prototype.check = function () {
        var _this = this;
        // Check for Wodax-project Or Npm
        var wodaxConfig = this.getWodaXConfig(this.templateClassId, this.templateKey);
        this.options.runCheckByFuncName = wodaxConfig ? 'checkWodaX' : 'checkNpm';
        if (this.hasCallback) {
            (function () { return __awaiter(_this, void 0, void 0, function () {
                var fn, _a, _b, error_1;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            _c.trys.push([0, 2, , 3]);
                            fn = wodaxConfig ? this.checkWodaX : this.checkNpm;
                            _a = this.callback;
                            _b = [null];
                            return [4 /*yield*/, fn.bind(this)()];
                        case 1:
                            _a.apply(this, _b.concat([_c.sent(), this]));
                            return [3 /*break*/, 3];
                        case 2:
                            error_1 = _c.sent();
                            this.callback(error_1);
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            }); })();
            return;
        }
        if (!this.config ||
            this.config.get('optOut') ||
            this.disabled) {
            return;
        }
        this.update = this.config.get('update');
        if (this.update) {
            this.config.delete('update');
        }
        // Only check for updates on a set interval
        if (Date.now() - this.config.get('lastUpdateCheck') < this.updateCheckInterval) {
            return;
        }
        // Spawn a detached process, passing the options as an environment property
        var argvString = JSON.stringify(this.options);
        console.log(argvString);
        spawn(process.execPath, [path.join(__dirname, 'check.js'), argvString], {
            detached: true,
            stdio: 'ignore',
            env: __assign(__assign({}, process.env), { 'NODE_OPTIONS': "--max_old_space_size=4096" })
        }).unref();
    };
    /** Get config information from wodax-config.js
     * @param {String} templateClassId  eg："00-wodax-ebmp"
     * @param {String} templateKey  eg："business-app-backstage"
     * @returns {null} config object, maybe null or undefended
     */
    UpdateNotifier.prototype.getWodaXConfig = function (templateClassId, templateKey) {
        if (!this.templateClassId || !this.templateKey) {
            return null;
        }
        return _.get(mapWodaXConfigs, [templateClassId, templateKey]) || null;
    };
    UpdateNotifier.prototype.checkInSemverList = function (versionType) {
        if (!!!versionType)
            return false;
        return [
            "patch",
            "prepatch",
            "major",
            "premajor",
            "minor",
            "preminor"
        ].includes(versionType);
    };
    UpdateNotifier.prototype.printSemverInfo = function (_a) {
        var packageName = _a.packageName, packageVersion = _a.packageVersion, newVersion = _a.newVersion, versionType = _a.versionType;
        if (this.checkInSemverList(versionType)) {
            console.log(chalk().gray(">>> \u25E2\u2586\u2585\u2584\u2583\u2583\u2584\u2585\u2587\u25E3") + " \u68C0\u6D4B\u5230: >>> [" + packageName + "@" + packageVersion + " -> " + newVersion + "] ....");
        }
    };
    UpdateNotifier.prototype.checkWodaX = function () {
        return __awaiter(this, void 0, void 0, function () {
            var config, keyStable, keyUnStable, keyDiscard, keyTemplateVersion, repeatNum, fmtPackageVersion, tplVersion, projectName, gitUrl, gitBranch, information, pkgDiscard, projectName, information, pkgUnStableVersions, projectName, information, tips, uninstallCmd, distTag, pkgStableVersion, versionType;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.options.runCheckByFuncName = 'checkWodaX';
                        config = this.getWodaXConfig(this.templateClassId, this.templateKey) || {};
                        keyStable = 'stable';
                        keyUnStable = 'unstable';
                        keyDiscard = 'discard';
                        keyTemplateVersion = 'version';
                        repeatNum = 3;
                        fmtPackageVersion = this.packageVersion.replace(/[\^,~]/g, "");
                        tplVersion = _.get(config, [keyTemplateVersion]);
                        if (tplVersion && this.templateVersion) {
                            projectName = "\"" + this.templateClassId + "\">\"" + this.templateKey + "\"";
                            gitUrl = _.get(config, ['vcs', 'url']);
                            gitBranch = _.get(config, ['vcs', 'branch']);
                            information = "" + '\n' +
                                (" 1.[\u6A21\u677F\u540D\u79F0] " + chalk().blue.underline(projectName)) + '\n' +
                                (" 2.[\u7248\u672C\u4FE1\u606F] \u5F53\u524D\uFF1A" + chalk().cyan.underline(this.templateVersion) + " " + chalk().reset(' → ') + " \u8FDC\u7AEF\uFF1A" + chalk().cyan.underline(tplVersion)) + '\n' +
                                (" 3.[\u4ED3\u5E93\u5730\u5740] " + gitUrl + " ") + '\n' +
                                (" 4.[\u4ED3\u5E93\u5206\u652F] " + gitBranch + " ") + '\n' +
                                (" " + chalk().red('-'.repeat(60)));
                            console.log(chalk().red('▶ '.repeat(repeatNum)) + " \u6A21\u677F\u8BF4\u660E\uFF1A\n" +
                                ("" + information));
                        }
                        pkgDiscard = _.get(config, [keyDiscard, this.packageName]);
                        if (pkgDiscard) {
                            projectName = "" + chalk().red.underline.bold(this.packageName);
                            information = "" + chalk().red.bold('已经被废弃，不建议使用 ... ✘ ');
                            console.log(chalk().black('☠ '.repeat(repeatNum)) + " " + projectName + " : " + information);
                        }
                        pkgUnStableVersions = _.get(config, [keyUnStable, this.packageName]) || [];
                        if (pkgUnStableVersions.includes(fmtPackageVersion)) {
                            projectName = "" + chalk().red.underline.bold(this.packageName);
                            information = "" + chalk().red.bold("\u529F\u80FD\u4E0D\u7A33\u5B9A\uFF0C\u8BF7\u4F7F\u7528\u7A33\u5B9A\u7248\u672C, \u5DE5\u5177\u81EA\u52A8\u5378\u8F7D\u4E0D\u7A33\u5B9A\u7248\u672C ... \u2718 ");
                            tips = "\n" + chalk().red.underline.bold("\u8FD9\u4E9B\u90FD\u5C5E\u4E8E\u5DF2\u53D1\u73B0\u7684\u4E0D\u7A33\u5B9A\u7248\u672C\uFF1A[" + pkgUnStableVersions.join(",") + "]");
                            console.log(chalk().black('☠ '.repeat(repeatNum)) + " " + projectName + "@" + fmtPackageVersion + " : " + information + " " + tips);
                            uninstallCmd = this.getUnInstallCommand(this.packageName);
                            try {
                                console.log(chalk().cyan(uninstallCmd) + " \u547D\u4EE4\uFF0C\u8BF7\u8010\u5FC3\u7B49\u5F85 ...");
                                execa.commandSync(uninstallCmd, {
                                    timeout: 1000 * 60 * 10,
                                    env: __assign(__assign({}, process.env), { 'NODE_OPTIONS': "--max_old_space_size=4096" })
                                });
                            }
                            catch (e) { }
                            return [2 /*return*/, {
                                    latest: fmtPackageVersion,
                                    current: this.packageVersion,
                                    type: null,
                                    name: this.packageName,
                                    scope: 'wodax'
                                }];
                        }
                        distTag = this.options.distTag;
                        pkgStableVersion = _.get(config, [keyStable, this.packageName]);
                        if (pkgStableVersion) {
                            versionType = distTag;
                            try {
                                // console.log(`call checkWodaX`, this.packageName, this.packageVersion, pkgStableVersion);
                                versionType = semverDiff()(fmtPackageVersion, pkgStableVersion) || distTag;
                                // console.log(`${this.packageName} - ${versionType}`);
                            }
                            catch (e) {
                                console.error(e);
                            }
                            this.printSemverInfo({
                                packageName: this.packageName,
                                packageVersion: this.packageVersion,
                                newVersion: pkgStableVersion,
                                versionType: versionType
                            });
                            return [2 /*return*/, {
                                    latest: pkgStableVersion,
                                    current: this.packageVersion,
                                    type: versionType,
                                    name: this.packageName,
                                    scope: 'wodax'
                                }];
                        }
                        return [4 /*yield*/, this.checkNpm()];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    UpdateNotifier.prototype.checkNpm = function () {
        return __awaiter(this, void 0, void 0, function () {
            var distTag, latest, versionType, fmtPackageVersion;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        distTag = this.options.distTag;
                        return [4 /*yield*/, latestVersion()(this.packageName, { version: distTag })];
                    case 1:
                        latest = _a.sent();
                        this.options.runCheckByFuncName = 'checkNpm';
                        versionType = null;
                        try {
                            fmtPackageVersion = this.packageVersion.replace(/\^/g, "");
                            if (fmtPackageVersion !== 'latest') {
                                versionType = semverDiff()(fmtPackageVersion, latest);
                            }
                        }
                        catch (e) {
                            console.error(e);
                        }
                        this.printSemverInfo({
                            packageName: this.packageName,
                            packageVersion: this.packageVersion,
                            newVersion: latest,
                            versionType: versionType
                        });
                        return [2 /*return*/, {
                                latest: latest,
                                current: this.packageVersion,
                                type: versionType,
                                name: this.packageName,
                                scope: 'npm'
                            }];
                }
            });
        });
    };
    /** Notify
     * @param {Object} options  a init options
     * @returns {UpdateNotifier} a UpdateNotifier Object
     */
    UpdateNotifier.prototype.notify = function (options) {
        var suppressForNpm = !this.shouldNotifyInNpmScript && isNpm().isNpm;
        if (suppressForNpm || !this.update) {
            return this;
        }
        options = __assign({ isGlobal: isInstalledGlobally(), isYarnGlobal: isYarnGlobal()() }, options);
        var installCommand = this.getInstallCommand(options);
        var forWodaX = ((this.options.runCheckByFuncName === 'checkWodaX') || matchCurrentPackage(this.packageName));
        var messageCaption = forWodaX ?
            // chalk().black.bgWhite.underline.bold(' WodaX 项目依赖强制检测 ') + '\n' :
            chalk().underline.bold(' WodaX 项目依赖强制检测 ') + '\n' :
            '';
        var captionUpdate = forWodaX ? '可用更新:' : '发现可用更新';
        var tipUpdate = forWodaX ? '\n使用 ' : '\n【非强制核心更新】 要更新，可使用 ';
        options.message = options.message || messageCaption + (captionUpdate + "\uFF1A " + this.packageName + " ") + chalk().dim(this.update.current) + chalk().dim(' → ') +
            chalk().green(this.update.latest) + ("" + tipUpdate) + chalk().cyan(installCommand) + ' 命令更新依赖';
        options.boxenOpts = options.boxenOpts || {
            padding: 1,
            margin: 1,
            align: 'center',
            backgroundColor: options.isMilestone ? '#000000' : '',
            borderColor: options.isMilestone ? '#ff0000' : 'yellow',
            borderStyle: options.isMilestone ? 'bold' : 'round'
        };
        var message = '\n' + boxen()(options.message, options.boxenOpts);
        if (options.defer === false) {
            console.error(message);
        }
        else {
            process.on('exit', function () {
                console.error(message);
            });
            process.on('SIGINT', function () {
                console.error('');
                process.exit();
            });
        }
        return this;
    };
    UpdateNotifier.prototype.printInfo = function (options) {
        options = __assign({ isGlobal: isInstalledGlobally(), isYarnGlobal: isYarnGlobal()() }, options);
        this.update = this.config.get('update');
        var installCommand = this.getInstallCommand({ options: options, latestVersion: this.update.latest });
        var forWodaX = ((this.options.runCheckByFuncName === 'checkWodaX') || matchCurrentPackage(this.packageName));
        var messageCaption = forWodaX ?
            // chalk().black.bgWhite.underline.bold(' WodaX 项目依赖强制检测 ') + '\n' :
            chalk().underline.bold(' WodaX 项目依赖强制检测 ') + '\n' :
            '';
        var captionUpdate = forWodaX ? '可用更新:' : '发现可用更新';
        var tipUpdate = forWodaX ? '\n使用 ' : '\n【非强制核心更新】 要更新，可使用 ';
        options.message = options.message || messageCaption + (captionUpdate + "\uFF1A " + this.packageName + " ") + chalk().dim(this.update.current) + chalk().dim(' → ') +
            chalk().green(this.update.latest) + ("" + tipUpdate) + chalk().cyan(installCommand) + ' 命令更新依赖';
        options.isMilestone = options.isMilestone || false;
        options.boxenOpts = options.boxenOpts || {
            padding: options.isMilestone ? 2 : 1,
            margin: options.isMilestone ? 2 : 1,
            align: 'center',
            backgroundColor: options.isMilestone ? '#000000' : '',
            borderColor: options.isMilestone ? '#ff0000' : 'yellow',
            borderStyle: options.isMilestone ? 'bold' : 'round'
        };
        var message = '\n' + boxen()(options.message, options.boxenOpts);
        console.log(message);
        // Note: Try update the wodax project
        try {
            if (forWodaX && !matchCurrentPackage(this.packageName)) {
                console.log("\u5F3A\u5236\u4F9D\u8D56\u66F4\u65B0\uFF1A\u6B63\u5728\u5C1D\u8BD5\u6267\u884C " + chalk().cyan(installCommand) + " \u547D\u4EE4\uFF0C\u8BF7\u8010\u5FC3\u7B49\u5F85 ...");
                console.log("\u5982\u679C\u66F4\u65B0\u5931\u8D25\uFF0C\u8BF7\u5728\u7EC8\u7AEF\u4E2D\u624B\u52A8\u8FD0\u884C\u8BE5\u547D\u4EE4 '" + installCommand + "' ...");
                execa.commandSync(installCommand, {
                    timeout: 1000 * 60 * 10,
                    env: __assign(__assign({}, process.env), { 'NODE_OPTIONS': "--max_old_space_size=4096" })
                });
            }
        }
        catch (e) {
            console.error(e);
            process.exit(1);
        }
        return this;
    };
    UpdateNotifier.GetCurrentRunIsNPMCLI = function () {
        return /npm-cli\.js$|npm-cli$/.test(process.env['npm_execpath']);
    };
    UpdateNotifier.GetCurrentRunIsYarnCLI = function () {
        return /yarn\.js$|yarnpkg$/.test(process.env['npm_execpath']);
    };
    UpdateNotifier.GetCurrentRunIsCNPMCLI = function () {
        return /cnpm$/.test(process.env['npm_execpath']);
    };
    UpdateNotifier.GetCurrentRunISPNMPCLI = function () {
        return /pnpm\.js$/.test(process.env['npm_execpath']);
    };
    UpdateNotifier.GetHasYarnLockFile = function () {
        var exist = false;
        try {
            var dir = "" + path.normalize(path.join(__dirname, "../../", "yarn.lock"));
            exist = fse.pathExistsSync("" + dir);
        }
        catch (e) { }
        return exist;
    };
    UpdateNotifier.GetUninstallCommand = function (options) {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        var command = '';
        var yarnCommandGlobal = "yarn global remove " + ((_a = options) === null || _a === void 0 ? void 0 : _a.packageName);
        var yarnCommand = "yarn remove " + ((_b = options) === null || _b === void 0 ? void 0 : _b.packageName);
        var npmCommand = "npm uninstall " + (((_c = options) === null || _c === void 0 ? void 0 : _c.isGlobal) ? '-g ' : '') + ((_d = options) === null || _d === void 0 ? void 0 : _d.packageName);
        /// 强化使用yarn来安装包
        if ((_e = options) === null || _e === void 0 ? void 0 : _e.isYarnGlobal) {
            command = yarnCommandGlobal;
        }
        else if ((_f = UpdateNotifier) === null || _f === void 0 ? void 0 : _f.GetCurrentRunIsYarnCLI()) {
            command = yarnCommand;
        }
        else if (hasYarn()() && ((_g = UpdateNotifier) === null || _g === void 0 ? void 0 : _g.GetHasYarnLockFile())) {
            command = yarnCommand;
        }
        else if ((_h = UpdateNotifier) === null || _h === void 0 ? void 0 : _h.GetCurrentRunIsNPMCLI()) {
            command = npmCommand;
        }
        else if (hasYarn()()) {
            command = yarnCommand;
        }
        else {
            command = npmCommand;
        }
        return command;
    };
    UpdateNotifier.prototype.getUnInstallCommand = function (packageName) {
        return UpdateNotifier.GetUninstallCommand({
            packageName: packageName,
            isYarnGlobal: isInstalledGlobally(),
            isGlobal: isYarnGlobal()(),
        });
    };
    UpdateNotifier.GetInstallCommand = function (options) {
        var installCommand;
        var dependenciesOptions = "" + {
            devDependencies: '-D',
            optionalDependencies: '-O',
            dependencies: '',
            peerDependency: '-P',
            bundleDependencies: '-B'
        }[options.dependenciesType];
        var yarnCommandGlobal = "yarn global add " + options.packageName + "@" + options.latestVersion;
        var yarnCommand = "yarn add " + options.packageName + "@" + options.latestVersion + " " + dependenciesOptions;
        var npmCommand = "npm i " + (options.isGlobal ? '-g ' : '') + options.packageName + "@" + options.latestVersion + " " + dependenciesOptions;
        /// 强化使用yarn来安装包
        if (options.isYarnGlobal) {
            installCommand = yarnCommandGlobal;
        }
        else if (UpdateNotifier.GetCurrentRunIsYarnCLI()) {
            installCommand = yarnCommand;
        }
        else if (hasYarn()() && UpdateNotifier.GetHasYarnLockFile()) {
            installCommand = yarnCommand;
        }
        else if (UpdateNotifier.GetCurrentRunIsNPMCLI()) {
            installCommand = npmCommand;
        }
        else if (hasYarn()()) {
            installCommand = yarnCommand;
        }
        else {
            installCommand = npmCommand;
        }
        return installCommand;
    };
    UpdateNotifier.prototype.getInstallCommand = function (options) {
        var installCommand = UpdateNotifier.GetInstallCommand({
            dependenciesType: this.dependenciesType,
            packageName: this.packageName,
            latestVersion: options.latestVersion,
            isYarnGlobal: options.isYarnGlobal,
            isGlobal: options.isGlobal,
        });
        return installCommand;
    };
    return UpdateNotifier;
}());
var createUpdateNotifier = function (options) {
    // @ts-ignore
    var pkg = __assign({ pkg: { name: '', version: '' } }, options).pkg;
    var name = pkg.name, version = pkg.version;
    console.log(chalk().gray(">>> \u25E2\u2586\u2585\u2584\u2583\u2583\u2584\u2585\u2587\u25E3") + " \u6B63\u5728\u6267\u884C\u4F9D\u8D56\u66F4\u65B0\u68C0\u6D4B\u7A0B\u5E8F: >>> [" + name + "@" + version + "] ....");
    var updateNotifier = new UpdateNotifier(options);
    updateNotifier.check();
    return updateNotifier;
};
function CheckGitSettings() {
    [
        "git config core.autocrlf false",
        "git config core.ignorecase false",
        "git config core.quotepath off",
        "git config gui.encoding utf-8",
    ].forEach(function (command) {
        try {
            require('child_process').execSync(command);
        }
        catch (e) {
        }
    });
}
function SelfCheck(cb) {
    var pkgInfo = require('./package.json');
    var packageName = pkgInfo.name, packageVersion = pkgInfo.version;
    console.log(chalk().gray(">>> \u0285\uFF08\u00B4\u25D4\u0C6A\u25D4\uFF09\u0283") + " \u6267\u884C '" + packageName + "' \u81EA\u68C0\u7A0B\u5E8F ....");
    // 1. 检查Git环境设置
    CheckGitSettings();
    // 2. 更新模板补丁核心文件
    try {
        var patch = require('./patch');
        patch.tryApplyPatches(false);
    }
    catch (e) {
        console.trace(e);
    }
    // 3. 自检开始
    var dependenciesType = 'devDependencies';
    createUpdateNotifier({
        pkg: {
            name: packageName,
            version: packageVersion,
            dependenciesType: dependenciesType
        },
        updateCheckInterval: 0,
        callback: function (err, info, instance) {
            var needUpdate = false;
            var installCommand = UpdateNotifier.GetInstallCommand({
                dependenciesType: dependenciesType,
                packageName: packageName,
                latestVersion: "latest",
                isGlobal: isInstalledGlobally(),
                isYarnGlobal: isYarnGlobal()(),
            });
            if (err) {
                console.error(err);
            }
            else {
                try {
                    var type = info.type;
                    console.log(chalk().green(">>> \u25E2\u2586\u2585\u2584\u2583\u2583\u2584\u2585\u2587\u25E3") + " \u89E3\u6790\u4FE1\u606F: >>> [" + packageName + "@" + packageVersion + "] [type = " + type + "]....");
                    var handler = (instance !== undefined && instance !== null) ? instance : this;
                    if (type && type !== 'latest') {
                        needUpdate = true;
                        try {
                            handler.config.set('update', info);
                        }
                        catch (e) { }
                        try {
                            handler.printInfo({ info: info, isMilestone: true });
                        }
                        catch (e) { }
                    }
                }
                catch (e) {
                    console.error(e);
                }
            }
            if (typeof cb === 'function') {
                cb(err, { packageName: packageName, needUpdate: needUpdate, installCommand: installCommand });
            }
        }
    });
}
module.exports = createUpdateNotifier;
module.exports.UpdateNotifier = UpdateNotifier;
module.exports.selfCheckUpdate = SelfCheck;
//# sourceMappingURL=index.js.map